﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace ogrenciotomasyonu
{
    public partial class Form1 : Form
    {

        MySqlDataAdapter da_ogrenci, da_dersler, da_ogrenciders;

        public Form1()
        {
            InitializeComponent();
            MySqlConnectionStringBuilder bag = new MySqlConnectionStringBuilder();
            bag.Server = "localhost";
            bag.UserID = "root";
            bag.Password = "123456";
            bag.Database = "hafta8";

            MySqlConnection conn = new MySqlConnection(bag.ToString());
            
            MySqlCommand cmd_ogrenci_sel = new MySqlCommand("select idogrenci,adi from ogrenci;", conn);
            MySqlCommand cmd_ogrenci_ins = new MySqlCommand("insert into ogrenci(adi) values(@adi);", conn);
            cmd_ogrenci_ins.Parameters.Add("@adi", MySqlDbType.VarChar, 45, "adi");

            da_ogrenci = new MySqlDataAdapter();
            da_ogrenci.SelectCommand = cmd_ogrenci_sel;
            da_ogrenci.InsertCommand = cmd_ogrenci_ins;



            MySqlCommand cmd_dersler_sel = new MySqlCommand("select iddersler,dersadi,aa,ba,bb,cb,cc,dc,dd,fd from dersler;", conn);
            MySqlCommand cmd_dersler_ins = new MySqlCommand("insert into dersler(dersadi,aa,ba,bb,cb,cc,dc,dd,fd) values(@dersadi,@aa,@ba,@bb,@cb,@cc,@dc,@dd,@fd);", conn);
            cmd_dersler_ins.Parameters.Add("@dersadi", MySqlDbType.VarChar, 45, "dersadi");
            cmd_dersler_ins.Parameters.Add("@aa", MySqlDbType.Int32, 11, "aa");
            cmd_dersler_ins.Parameters.Add("@ba", MySqlDbType.Int32, 11, "ba");
            cmd_dersler_ins.Parameters.Add("@bb", MySqlDbType.Int32, 11, "bb");
            cmd_dersler_ins.Parameters.Add("@cb", MySqlDbType.Int32, 11, "cb");
            cmd_dersler_ins.Parameters.Add("@cc", MySqlDbType.Int32, 11, "cc");
            cmd_dersler_ins.Parameters.Add("@dc", MySqlDbType.Int32, 11, "dc");
            cmd_dersler_ins.Parameters.Add("@dd", MySqlDbType.Int32, 11, "dd");
            cmd_dersler_ins.Parameters.Add("@fd", MySqlDbType.Int32, 11, "fd");

            MySqlCommand cmd_dersler_upd = new MySqlCommand("update dersler set dersadi=@dersadi,aa=@aa,ba=@ba,bb=@bb,cb=@cb,cc=@cc,dc=@dc,dd=@dd,fd=@fd where iddersler=@iddersler;", conn);
            cmd_dersler_upd.Parameters.Add("@iddersler", MySqlDbType.Int32, 11, "iddersler");
            cmd_dersler_upd.Parameters.Add("@dersadi", MySqlDbType.VarChar, 45, "dersadi");
            cmd_dersler_upd.Parameters.Add("@aa", MySqlDbType.Int32, 11, "aa");
            cmd_dersler_upd.Parameters.Add("@ba", MySqlDbType.Int32, 11, "ba");
            cmd_dersler_upd.Parameters.Add("@bb", MySqlDbType.Int32, 11, "bb");
            cmd_dersler_upd.Parameters.Add("@cb", MySqlDbType.Int32, 11, "cb");
            cmd_dersler_upd.Parameters.Add("@cc", MySqlDbType.Int32, 11, "cc");
            cmd_dersler_upd.Parameters.Add("@dc", MySqlDbType.Int32, 11, "dc");
            cmd_dersler_upd.Parameters.Add("@dd", MySqlDbType.Int32, 11, "dd");
            cmd_dersler_upd.Parameters.Add("@fd", MySqlDbType.Int32, 11, "fd");


            // update yapilacak

            da_dersler = new MySqlDataAdapter();
            da_dersler.SelectCommand = cmd_dersler_sel;
            da_dersler.InsertCommand = cmd_dersler_ins;
            da_dersler.UpdateCommand = cmd_dersler_upd;


            MySqlCommand cmd_ogrenciders_sel = new MySqlCommand("select idogrenciders,ogrenciid,dersid,vize,final,adi,dersadi,aa,ba,bb,cb,cc,dc,dd,fd from ogrenciders inner join ogrenci on idogrenci=ogrenciid inner join dersler on iddersler=dersid;", conn);
            MySqlCommand cmd_ogrenciders_ins = new MySqlCommand("insert into ogrenciders(ogrenciid,dersid,vize,final) values(@ogrenciid,@dersid,@vize,@final);", conn);
            cmd_ogrenciders_ins.Parameters.Add("@ogrenciid", MySqlDbType.Int32, 11, "ogrenciid");
            cmd_ogrenciders_ins.Parameters.Add("@dersid", MySqlDbType.Int32, 11, "dersid");
            cmd_ogrenciders_ins.Parameters.Add("@vize", MySqlDbType.Int32, 11, "vize");
            cmd_ogrenciders_ins.Parameters.Add("@final", MySqlDbType.Int32, 11, "final");

            da_ogrenciders = new MySqlDataAdapter();
            da_ogrenciders.SelectCommand = cmd_ogrenciders_sel;
            da_ogrenciders.InsertCommand = cmd_ogrenciders_ins;


            ogrenci_combodoldur();
            dersler_combodoldur();
            ogrenciders_listboxdoldur();
        }


        DataTable dt_ogrenciders;
        private void ogrenciders_listboxdoldur()
        {
            try
            {
                dt_ogrenciders = new DataTable();
                logrenci.Items.Clear();
                lders.Items.Clear();
                lvize.Items.Clear();
                lfinal.Items.Clear();
                lortalama.Items.Clear();
                lharf.Items.Clear();
                da_ogrenciders.Fill(dt_ogrenciders);

                for (int satir = 0; satir < dt_ogrenciders.Rows.Count; satir++)
                {
                    logrenci.Items.Add(dt_ogrenciders.Rows[satir].ItemArray[5].ToString());
                    lders.Items.Add(dt_ogrenciders.Rows[satir].ItemArray[6].ToString());
                    lvize.Items.Add(dt_ogrenciders.Rows[satir].ItemArray[3].ToString());
                    lfinal.Items.Add(dt_ogrenciders.Rows[satir].ItemArray[4].ToString());
                    int vize = Convert.ToInt32(dt_ogrenciders.Rows[satir].ItemArray[3].ToString());
                    int final = Convert.ToInt32(dt_ogrenciders.Rows[satir].ItemArray[4].ToString());
                    int ort =(int)Math.Round(vize * 0.4 + final * 0.6);
                    lortalama.Items.Add(ort.ToString());
                    string harf = harfhesapla(ort, satir);
                    lharf.Items.Add(harf);
                }

            }
            catch { }
        }


        private string harfhesapla(int ort,int index)
        { // index bilgisi hangi ogrenciye ait kaydin kullanildigini belirten deger

            // AA - FD 
            String[] harfler = { "AA", "BA", "BB", "CB", "CC", "DC", "DD", "FD" };
            for(int i=0;i<8;i++)
            {
                int aralik = Convert.ToInt32(dt_ogrenciders.Rows[index].ItemArray[7 + i].ToString());
                if (ort >= aralik)
                    return harfler[i];
            }

            return "FF";
        }

        DataTable dt_dersler;
        private void dersler_combodoldur()
        {
            try
            {
                dt_dersler = new DataTable();
                cders.Items.Clear();
                da_dersler.Fill(dt_dersler);

                for (int satir = 0; satir < dt_dersler.Rows.Count; satir++)
                {
                    cders.Items.Add(dt_dersler.Rows[satir].ItemArray[1].ToString());
                }

            }
            catch
            {

            }
            cders.Text = "Seçiniz";
        
        }



        DataTable dt_ogrenci;
        private void ogrenci_combodoldur() {

            try
            {
                dt_ogrenci = new DataTable();
                cogrenci.Items.Clear();
                da_ogrenci.Fill(dt_ogrenci);

                for (int satir = 0; satir < dt_ogrenci.Rows.Count; satir++)
                {
                    cogrenci.Items.Add(dt_ogrenci.Rows[satir].ItemArray[1].ToString());
                }
            }
            catch {
            }

            cogrenci.Text = "Seçiniz";
          
        
        }


        private void bekle_Click(object sender, EventArgs e)
        {
            try
            {
                int vize, final;
                bool v_kontrol = Int32.TryParse(tvize.Text, out vize);
                bool f_kontrol = Int32.TryParse(tfinal.Text, out final);

                int index_ogrenci=cogrenci.SelectedIndex;
                int index_dersler=cders.SelectedIndex;

                if (v_kontrol && f_kontrol && index_dersler > -1 && index_ogrenci > -1)
                {
                    DataRow dr = dt_ogrenciders.NewRow();
                    dr["ogrenciid"] = Convert.ToInt32(dt_ogrenci.Rows[index_ogrenci].ItemArray[0].ToString());
                    dr["dersid"] = Convert.ToInt32(dt_dersler.Rows[index_dersler].ItemArray[0].ToString());
                    dr["vize"] = vize;
                    dr["final"] = final;

                    dt_ogrenciders.Rows.Add(dr);
                    da_ogrenciders.Update(dt_ogrenciders);
                }

                tvize.Clear();
                tfinal.Clear();
                cogrenci.SelectedIndex = -1;
                cders.SelectedIndex = -1;
                cogrenci.Text = "Seçiniz";
                cders.Text = "Seçiniz";
                



            }
            catch {
            }

            ogrenciders_listboxdoldur();
           

        }

        private void bogrenciler_Click(object sender, EventArgs e)
        {
            fogrenciler frm = new fogrenciler(da_ogrenci);
            frm.ShowDialog();
            ogrenci_combodoldur();
        }

        private void bdersler_Click(object sender, EventArgs e)
        {
            fdersler frm = new fdersler(da_dersler);
            frm.ShowDialog();
            dersler_combodoldur();
            ogrenciders_listboxdoldur();

        }
    }
}
