﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace ogrenciotomasyonu
{
    public partial class fdersler : Form
    {

        MySqlDataAdapter da_dersler;
        ListBox[] listbox;
        TextBox[] textbox; 
        String[] harf = { "aa", "ba", "bb", "cb", "cc", "dc", "dd", "fd" };

        public fdersler(MySqlDataAdapter da)
        {
            InitializeComponent();
            listbox= new ListBox[]{ laa, lba, lbb, lcb, lcc, ldc, ldd, lfd };
            textbox = new TextBox[] { taa, tba, tbb, tcb, tcc, tdc, tdd, tfd };

            da_dersler = da;
            dersler_listboxdoldur();
        }

        DataTable dt_dersler;
        private void dersler_listboxdoldur()
        {
            try
            {
                dt_dersler = new DataTable();
                lders.Items.Clear();
                for (int i = 0; i < listbox.Length; i++)
                    listbox[i].Items.Clear(); // laa--lfd ye kadar olanlar silindi

                da_dersler.Fill(dt_dersler);

                for (int satir = 0; satir < dt_dersler.Rows.Count; satir++)
                {
                    lders.Items.Add(dt_dersler.Rows[satir].ItemArray[1].ToString());
                    for (int i = 0; i < listbox.Length; i++)
                        listbox[i].Items.Add(dt_dersler.Rows[satir].ItemArray[2+i].ToString());
                
                }


            }
            catch
            { 
            
            }
        
        
        }

        private bool alankontrol()
        {
           

            if (tders.Text.Length > 0)
            {

                for (int i = 0; i < textbox.Length; i++)
                {
                    int sayi;
                    bool kontrol = Int32.TryParse(textbox[i].Text, out sayi);

                    if (!kontrol)
                        return false;

                    if (sayi < 0 || sayi > 100) // sayinin 0-100 araligina bakar
                        return false;
                }
                return true;
            }

            return false;
        }

        private void bekle_Click(object sender, EventArgs e)
        {
            try
            {
                if (alankontrol())
                {
                    DataRow dr = dt_dersler.NewRow();
                    dr["dersadi"] = tders.Text;
                    tders.Clear();
                    for (int i = 0; i < textbox.Length; i++)
                    {
                        dr[harf[i]] = Convert.ToInt32(textbox[i].Text);
                        textbox[i].Clear();
                    }

                    dt_dersler.Rows.Add(dr);
                    da_dersler.Update(dt_dersler);
                }
                else
                    MessageBox.Show("Girilen alanları kontrol ediniz!");
            }
            catch { 
            
            }

            dersler_listboxdoldur();
           

        }

        private void bguncelle_Click(object sender, EventArgs e)
        {
            try
            {
                int index = lders.SelectedIndex;
                if (alankontrol() && index>-1)
                {

                    DataRow dr = dt_dersler.Rows[index];
                    dr["dersadi"] = tders.Text;

                    for (int i = 0; i < textbox.Length; i++)
                    {
                        dr[harf[i]] = Convert.ToInt32(textbox[i].Text);
                    }

                    da_dersler.Update(dt_dersler);

                    tders.Clear();
                    for (int i = 0; i < textbox.Length; i++)
                    {
                        textbox[i].Clear();
                    }

                }

            }
            catch { }
            dersler_listboxdoldur();
            
        }

        private void bgetir_Click(object sender, EventArgs e)
        {
            int index = lders.SelectedIndex; // degistirilecek bilginin indeksi

            if (index > -1)
            {

                tders.Text = lders.Items[index].ToString();

                for (int eleman = 0; eleman < textbox.Length; eleman++)
                {
                    textbox[eleman].Text = listbox[eleman].Items[index].ToString();
                }
            }


        }

        private void bkapat_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
